Perforce Helix Installer ("HI")
===
Welcome 
---
This is the home of the Perforce Helix Installer project.

Perforce [Helix](http://www.perforce.com/helix) is a unified platform for collaborative development, version management, and protection of intellectual property.  It consists of an integrated ecosystem of proven, enterprise-grade systems for versioning, code collaboration and review, continuous delivery.

Helix Installer is capabile of quickly transforming a vanilla machine -- virtual or bare metal -- into a demonstraion grade deployment of Helix, suitable for a Proof of Concept rollout.  Further, because the demo-grade uses the Perforce Server Deployment Package ([SDP](https://swarm.workshop.perforce.com/projects/perforce-software-sdp), also availalbe in The Workshop), it is very easy to convert it to a production-grade installation.

This is an alternative to the [Helix Enterprise Evaluation virtual appliance (OVA)](http://www.perforce.com/downloads/helix).

Features
---
* Fast.  Runs in under 20 minutes, including download time.
* Easy.  Provides reasonable defaults for port numbers, passwords, data storage areas, and all inputs that would otherwise require human interaction.
* Comprehensive.  Installs P4D and P4Broker, SDP, and a complete development pre-configured environment include Perl, P4Perl, Python, and P4Python, with appropraite shell environment settings to use them all immediately.  And more to come --  future versions will include Swarm, Git Fusion, and GitSwarm.
* Automates connection to the [Perforce Package Repository](http://package.perforce.com/).
* Pre-loads the [Perforce Sample Depot](http://answers.perforce.com/articles/KB/2439)
* Simplifies Entrerprise Deployment.  While optimized for getting going quickly, the Helix Installer is designd to enable a fast path from a PoC to small-scale production deployment following the Helix evaluation, with a nominal hop from there to a large-scale enterprise deployment.  It is based on the Consulting [Server Deployment Package (SDP)](https://swarm.workshop.perforce.com/projects/perforce-software-sdp), use by the Consulting Services team at Perforce to manage various Helix components in large, globally districuted organizations.

Usage in Test Suite (Sample)
---
The Component Based Development ([CBD](https://swarm.workshop.perforce.com/projects/perforce-software-cbd)) system, another project in The Workshop, uses this Helix Installer as part of its automated test suite.  In conjunction with Vagrant and Virtual Box, which build a vanilla VM from the groud up, the [CBD Test Suite](https://swarm.workshop.perforce.com/projects/perforce-software-cbd/files/main/test/auto_test_cbd_vagrant.sh) uses the Helix Installer to deploy a Perforce server, complete with Sample Depot test data set, plus Python and P4Python needed to test the CBD scripts.

Instructions and Usage Exmaple
---

The <CODE>reset\_sdp.sh</CODE> script is the only script that should be downloaded.  It downloads everything it needs, including other scripts and files from this Helix Installer package, executables from the Perforce FTP site, and the SDP from The Workshop (acquired by cloning).

Once installing a vanilla CentOS 6.7 (or similar) machine, do this as root:

<PRE>
useradd perforce

mkdir -p /depotdata/reset

chown -R perforce:perforce /depotdata/reset

cd /depotdata/reset

p4 -u ftp -p workshop.perforce.com:1666 print -q -o reset_sdp.sh //guest/tom_tyler/helix-installer/main/src/reset_sdp.sh

chmod +x reset_sdp.sh

./reset_sdp.sh -man

./reset_sdp.sh 2>&1 | tee reset_sdp.log
</PRE>

A similar procedure works for Mac OSX, except that the standard Mac interface is used for creating the <CODE>perforce</CODE> user account rather than the <CODE>useradd</CODE> command, and the <CODE>chown</CODE> command may need to specify a different group, depending on how the user account is created.

Helix Installer Roadmap
===

HI 1.0 (Available Now)
---

HI 1.0, available today, can install the following Helix Components, all fully configured an intgegrated:

* P4D 2015.2 - the Helix Versioning Engine, the core of Helix.
* P4Broker 2015.2 - the Helix Broker, enhances custom automation capabilities, simplifies maintenances.
* SDP 2015.2 - Consulting Services Server Deployment Package
* Swarm and Git Fusion packages are installed, but not configured.

Helix 1.5 (ETA February 2016) will add support for:
---
* Helix Swarm - Collaborative web-based code review and continuous delivery.
* Helix Git Fusion - enables Git collaboration and access to the Helix  Versioning Engine for Git users.
* Helix GitSwarm
* Optimized for easy Git repo insertion.  A <code>p4import</code> user is created and configured with an SSH key, ready to immediately start Git repo imports.  A supplemental <code>higf_import</code> tool imports Git the master branch of a git repos in a single step, needing only the cloning URL as input.

Platform Support
---
HI v1.0 supports: 

* CentOS/RHEL 6.5 thru 6.7.
* Limited support for Mac OSX/Darwin

Future releases may add support for other popular Linux distributions, including those using APT, e.g. Ubuntu and Debian.  It may well work as-is presently on other YUM-based installastions.

Contact Us
---
Please contact Perforce Consulting (mailto:Consulting@Perforce.com) for more information.

Project Status
---
This project is functional.

Safety Warning
---
Note that this software ***SHOULD NEVER EXIST*** on a Production Perforce server.  The is intended to quickly tear down and rebuild a fresh Perforce server (e.g. for operating test suites).  It shoudl not exist on a machine containing real Perforce data.
